---
title: OES_vertex_array_object
slug: Web/API/OES_vertex_array_object
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong>OES_vertex_array_object</strong> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and provides vertex array objects (VAOs) which encapsulate vertex array states. These objects keep pointers to vertex data and provide names for different sets of vertex data.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is only available to {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts. In {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}}, the functionality of this extension is available on the WebGL2 context by default and the constants and methods are available without the "<code>OES</code>" suffix.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>This extension exposes one new constant, which can be used in the {{domxref("WebGLRenderingContext.getParameter()", "gl.getParameter()")}} method:</p>

<dl>
	<dt><code>ext.VERTEX_ARRAY_BINDING_OES</code></dt>
	<dd>Returns a {{domxref("WebGLVertexArrayObject")}} object when used in the {{domxref("WebGLRenderingContext.getParameter()", "gl.getParameter()")}} method as the <code>pname</code> parameter.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>This extension exposes four new methods.</p>

<dl>
	<dt>{{domxref("OES_vertex_array_object.createVertexArrayOES()", "ext.createVertexArrayOES()")}}</dt>
	<dd>
	<p>Creates a new {{domxref("WebGLVertexArrayObject")}}.</p>
	</dd>
	<dt>{{domxref("OES_vertex_array_object.deleteVertexArrayOES()", "ext.deleteVertexArrayOES()")}}</dt>
	<dd>
	<p>Deletes a given {{domxref("WebGLVertexArrayObject")}}.</p>
	</dd>
	<dt>{{domxref("OES_vertex_array_object.isVertexArrayOES()", "ext.isVertexArrayOES()")}}</dt>
	<dd>
	<p>Returns <code>true</code> if a given object is a {{domxref("WebGLVertexArrayObject")}}.</p>
	</dd>
	<dt>{{domxref("OES_vertex_array_object.bindVertexArrayOES()", "ext.bindVertexArrayOES()")}}</dt>
	<dd>
	<p>Binds a given {{domxref("WebGLVertexArrayObject")}} to the buffer.</p>
	</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var oes_vao_ext = gl.getExtension('OES_vertex_array_object');
var vao = oes_vao_ext.createVertexArrayOES();
oes_vao_ext.bindVertexArrayOES(vao);

// ...
// calls to bindBuffer or vertexAttribPointer
// which will be "recorded" in the VAO
// ...
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('OES_vertex_array_object', '', 'OES_vertex_array_object')}}</td>
			<td>{{Spec2('OES_vertex_array_object')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.OES_vertex_array_object")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
	<li>{{domxref("WebGLRenderingContext.vertexAttribPointer()")}}</li>
	<li>WebGL2 equivalent methods:
	<ul>
		<li>{{domxref("WebGL2RenderingContext.createVertexArray()")}}</li>
		<li>{{domxref("WebGL2RenderingContext.deleteVertexArray()")}}</li>
		<li>{{domxref("WebGL2RenderingContext.isVertexArray()")}}</li>
		<li>{{domxref("WebGL2RenderingContext.bindVertexArray()")}}</li>
	</ul>
	</li>
</ul>
